
Baggins_Outfitter = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0")

local Baggins_Outfitter = Baggins_Outfitter

local dewdrop = AceLibrary:HasInstance("Dewdrop-2.0") and AceLibrary("Dewdrop-2.0")
local sets_table = {}

local function Matches(bag, slot, rule)

	if (bag == -1 or bag > 4) and not Outfitter.BankFrameIsOpen then
--		Outfitter:BankFrameOpened()
--		Outfitter:ItemList_FlushEquippableItems()
		Outfitter:Synchronize()
	end

	local setName = rule.set
	if not setName then return false end
	
	local pItemInfo = Outfitter:GetBagItemInfo(bag, slot)
	if not pItemInfo then return false end
	
	local vOutfits = Outfitter:GetOutfitsUsingItem(pItemInfo)
	if not vOutfits then return false end
	
	for key, outfit in pairs(vOutfits) do
		if setName == outfit.Name or setName == "Any" then
			return true
		end
	end
		
	return false
	
end

local function GetName(rule)
	local setName = rule.set or "???"
	return "Outfitter: " .. setName
end

local function CleanRule(rule)
	rule.set = "All"
end

local function setRuleSet(rule, set)
	rule.set = set
	Baggins:OnRuleChanged()
end

local function DewDropOptions(rule, level, value)
	if level == 1 then
		dewdrop:AddLine("text", "Outfitter", "isTitle", true)
		dewdrop:AddLine("text", "Any", "checked", rule.set == "Any", 'func', setRuleSet, 'arg1', rule, 'arg2', "Any")
	
		for key, subtable in pairs(sets_table) do
			dewdrop:AddLine("text", "Outfitter: " .. key, "isTitle", true)
			
			for subkey, value in pairs(subtable) do
				dewdrop:AddLine("text", value["Name"], "checked", rule.set == value["Name"], 'func', setRuleSet, 'arg1', rule, 'arg2', value["Name"])
			end
		end
	end
end

local function CacheSets()
	sets_table = {}

	for key, value in pairs(gOutfitter_Settings.Outfits) do
		sets_table[key] = gOutfitter_Settings.Outfits[key]
	end
end

local function OutfitUpdate()
	CacheSets()
	Baggins:ForceFullUpdate()
end

function Baggins_Outfitter:OnEnable()
	CacheSets()

	Baggins:AddCustomRule("Outfitter", {
		DisplayName = "Outfitter",
		Description = "Filter by used in Outfitter set.",
		Matches = Matches,
		GetName = GetName,
		CleanRule = CleanRule,
		DewDropOptions = DewDropOptions
	})
	
	Outfitter:RegisterOutfitEvent("EDIT_OUTFIT", function () OutfitUpdate() end )
end


